<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Test Range Slider</title>
    <link rel="stylesheet" href="range_slider.css">
    <style>
        body {
            font-family: sans-serif;
        }
        @media (prefers-color-scheme: dark) {
            body {
                color: #ffffff;
                background-color: #303030;
            }
        }
        .native-range {
            width: 100%;
        }
        .vertical-slider {
            position: relative;
            display: inline-block;
            height: 250px;
            margin-left: 8px;
            margin-right: 8px;
        }
    </style>
  </head>
  <body>
      <header><h1>Test Range Slider</h1></header>
      <section>
          <div>
              <input class="native-range" type="range">
          </div>
          <div>
              <div id="rs-1"></div>
              <div id="rs-3"></div>
              <div id="rs-5"></div>
              <div id="rs-7"></div>
              <div id="rs-9"></div>
          </div>
          <div>
              <div id="rs-2" class="vertical-slider"></div>
              <div id="rs-4" class="vertical-slider"></div>
              <div id="rs-6" class="vertical-slider"></div>
              <div id="rs-8" class="vertical-slider"></div>
              <div id="rs-10" class="vertical-slider"></div>
          </div>
          <div>
              <button id="btn-toggle-disabled">Toggle disabled</button>
              <button id="btn-destroy">Destroy</button>
              <button id="btn-create">Create</button>
              <button id="btn-set-val-0">Set 0</button>
          </div>
      </section>
      <script src="range_slider.min.js"></script>
      <script>
        (function () {
            'use strict'

            document.addEventListener(
                'DOMContentLoaded',
                start
            )

            function start () {
                var btnToggleDisabled
                var btnDestroy, btnCreate
                var btnSetVal0
                var rs1, rs2, rs3, rs4, rs5, rs6, rs7, rs8, rs9, rs10
                btnToggleDisabled =
                    document.getElementById('btn-toggle-disabled')
                btnToggleDisabled.addEventListener(
                    'click',
                    onToggleDisabled,
                    {
                        capture: false,
                        passive: true
                    }
                )
                btnDestroy = document.getElementById('btn-destroy')
                btnDestroy.addEventListener(
                    'click',
                    onDestroy,
                    {
                        capture: false,
                        passive: true
                    }
                )
                btnCreate = document.getElementById('btn-create')
                btnCreate.addEventListener(
                    'click',
                    onCreate,
                    {
                        capture: false,
                        passive: true
                    }
                )
                btnSetVal0 = document.getElementById('btn-set-val-0')
                btnSetVal0.addEventListener(
                    'click',
                    onSetVal0,
                    {
                        capture: false,
                        passive: true
                    }
                )
                rs1 = new gidw.RangeSlider({
                    element: 'rs-1',
                    progress: true
                })
                rs2 = new gidw.RangeSlider({
                    element: 'rs-2',
                    orientation: 'vertical',
                    progress: true
                })
                rs3 = new gidw.RangeSlider({
                    element: 'rs-3'
                })
                rs4 = new gidw.RangeSlider({
                    element: 'rs-4',
                    orientation: 'vertical'
                })
                rs5 = new gidw.RangeSlider({
                    element: 'rs-5',
                    progress: true,
                    min: -7,
                    max: 3,
                    step: 1,
                    start: 0,
                    setValueHook: function (currentVal, newValue) {
                        console.log('Value Hook', currentVal, newValue)
                        return -3
                    }
                })
                rs6 = new gidw.RangeSlider({
                    element: 'rs-6',
                    orientation: 'vertical',
                    progress: true,
                    min: -7,
                    max: 3,
                    step: 1,
                    start: 0
                })
                rs7 = new gidw.RangeSlider({
                    element: 'rs-7',
                    progress: true,
                    reverse: true
                })
                rs8 = new gidw.RangeSlider({
                    element: 'rs-8',
                    orientation: 'vertical',
                    progress: true,
                    reverse: true
                })
                rs9 = new gidw.RangeSlider({
                    element: 'rs-9',
                    progress: true,
                    reverse: true,
                    min: -7,
                    max: 3,
                    step: 1,
                    start: 0,
                    onChange: onChange,
                    onChanged: onChanged
                })
                rs10 = new gidw.RangeSlider({
                    element: 'rs-10',
                    orientation: 'vertical',
                    progress: true,
                    reverse: true,
                    min: -7,
                    max: 3,
                    step: 1,
                    start: 0,
                    value: 2
                })

                function onToggleDisabled () {
                    if (rs8) rs8.disabled = !rs8.disabled
                    if (rs9) rs9.disabled = !rs9.disabled
                }

                function onDestroy () {
                    if (rs8) rs8.destroy()
                    rs8 = null
                    if (rs9) rs9.destroy()
                    rs9 = null
                }

                function onCreate () {
                    if (rs8) rs8.destroy()
                    rs8 = new gidw.RangeSlider({
                        element: 'rs-8',
                        orientation: 'vertical',
                        progress: true,
                        reverse: true
                    })
                    if (rs9) rs9.destroy()
                    rs9 = new gidw.RangeSlider({
                        element: 'rs-9',
                        progress: true,
                        reverse: true,
                        min: -7,
                        max: 3,
                        step: 1,
                        start: 0,
                        onChange: onChange,
                        onChanged: onChanged
                    })
                }

                function onSetVal0 () {
                    if (rs5) rs5.setValue(0)
                }
            }
            function onChange (value) {
                console.log('onChange', value)
            }
            function onChanged (value) {
                console.log('onChanged', value)
            }
        }())
    </script>
  </body>
</html>
